﻿//
// TOTPlayerStarter.cs
//
// Copyright 2023 OTSUKI Takashi
// SPDX-License-Identifier: Apache-2.0
//

using AIWolf.Client;
using AIWolf.Lib;
using System;

namespace TOT2023
{
    class TOTPlayerStarter
    {
        static void Main(string[] args)
        {
            string host = "localhost";
            int port = 10000;
            Role roleRequest = Role.UNC;
            string playerName = "TOT";


            for (var i = 0; i < args.Length; i++)
            {
                if (args[i] == "-p")
                {
                    i++;
                    if (i < args.Length || !args[i].StartsWith("-"))
                    {
                        if (int.TryParse(args[i], out var p))
                        {
                            port = p;
                        }
                    }
                }
                else if (args[i] == "-h")
                {
                    i++;
                    if (i < args.Length || !args[i].StartsWith("-"))
                    {
                        host = args[i];
                    }
                }
                else if (args[i] == "-r")
                {
                    i++;
                    if (i < args.Length || !args[i].StartsWith("-"))
                    {
                        if (Enum.TryParse(args[i], out Role r))
                        {
                            roleRequest = r;
                        }
                    }
                }
                else if (args[i] == "-n")
                {
                    i++;
                    if (i < args.Length || !args[i].StartsWith("-"))
                    {
                        playerName = args[i];
                    }
                }
            }
            TcpipClient client = new TcpipClient(host, port, playerName, roleRequest);
            client.Connect(new TOTPlayer());
        }
    }
}